#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sdl.h>

#include "player.h"
#include "fformat.h"
#include "myendian.h"

emuEngine myEmuEngine;

static int fsize ( char * fname )
  {
    FILE * f;
    int s;

    f = fopen (fname,"rb");
    if (f==NULL)
      return -1;

    fseek(f, 0, SEEK_END);
    s=ftell(f);
    fclose(f);

    return s;
  }

static void mixaudio ( void * userdata, Uint8 * stream, int len )
  {
    sidTune * myTune = (sidTune*)userdata;

    sidEmuFillBuffer ( myEmuEngine,*myTune,stream,len );
  }

int main ( int argc, char *argv[] )
  {
    int fs;
    unsigned char * mem;
    FILE * fh;
    SDL_AudioSpec audioSpec;
    sidTune * myTune;
    struct sidTuneInfo mySidInfo;
    struct emuConfig myEmuConfig;

    if (argc<2)
      return 1;

    fs = fsize ( argv[1] );

    if ( fs<0 )
      return 1;

    mem = (unsigned char*)malloc ( fs );
    fh = fopen ( argv[1], "rb" );
    fread ( mem, 1, fs, fh );
    fclose ( fh );

    myTune = new sidTune ( mem, fs );

    /* Init SDL audio */
    audioSpec.freq = 44100;
    audioSpec.format = AUDIO_S16;
    audioSpec.channels = 2;
    audioSpec.samples = (audioSpec.freq/1);
    audioSpec.callback = mixaudio;
    audioSpec.userdata = (void*)myTune;
    if (SDL_OpenAudio(&audioSpec,NULL)<0)
      {
        fprintf(stderr,"Error while opening audio device\n");
        return 1;
      }

    myTune->getInfo ( mySidInfo );

    printf ( "%s\n", mySidInfo.nameString );
    printf ( "%s\n", mySidInfo.authorString );
    printf ( "%s\n", mySidInfo.copyrightString );

    myEmuEngine.getConfig ( myEmuConfig );

    myEmuConfig.frequency = 44100;
    myEmuConfig.channels = SIDEMU_STEREO;
    myEmuConfig.bitsPerSample = SIDEMU_16BIT;
    myEmuConfig.emulateFilter = true;

    myEmuEngine.setConfig ( myEmuConfig );

    printf ("InitializeSong: %d\n", sidEmuInitializeSong(myEmuEngine,*myTune,0));
    myEmuEngine.resetSecondsThisSong();

    SDL_PauseAudio(0);

    while(1);

    return 0;
  }

